#pragma once

#define GBA_REG_OFFS_DISPCNT      0x000
#define GBA_REG_OFFS_GREEN_SWAP   0x002
#define GBA_REG_OFFS_DISPSTAT     0x004
#define GBA_REG_OFFS_VCOUNT       0x006
#define GBA_REG_OFFS_BG0CNT       0x008
#define GBA_REG_OFFS_BG1CNT       0x00A
#define GBA_REG_OFFS_BG2CNT       0x00C
#define GBA_REG_OFFS_BG3CNT       0x00E
#define GBA_REG_OFFS_BG0HOFS      0x010
#define GBA_REG_OFFS_BG0VOFS      0x012
#define GBA_REG_OFFS_BG1HOFS      0x014
#define GBA_REG_OFFS_BG1VOFS      0x016
#define GBA_REG_OFFS_BG2HOFS      0x018
#define GBA_REG_OFFS_BG2VOFS      0x01A
#define GBA_REG_OFFS_BG3HOFS      0x01C
#define GBA_REG_OFFS_BG3VOFS      0x01E
#define GBA_REG_OFFS_BG2PA        0x020
#define GBA_REG_OFFS_BG2PB        0x022
#define GBA_REG_OFFS_BG2PC        0x024
#define GBA_REG_OFFS_BG2PD        0x026
#define GBA_REG_OFFS_BG2X         0x028
#define GBA_REG_OFFS_BG2X_L       0x028
#define GBA_REG_OFFS_BG2X_H       0x02A
#define GBA_REG_OFFS_BG2Y         0x02C
#define GBA_REG_OFFS_BG2Y_L       0x02C
#define GBA_REG_OFFS_BG2Y_H       0x02E
#define GBA_REG_OFFS_BG3PA        0x030
#define GBA_REG_OFFS_BG3PB        0x032
#define GBA_REG_OFFS_BG3PC        0x034
#define GBA_REG_OFFS_BG3PD        0x036
#define GBA_REG_OFFS_BG3X         0x038
#define GBA_REG_OFFS_BG3X_L       0x038
#define GBA_REG_OFFS_BG3X_H       0x03A
#define GBA_REG_OFFS_BG3Y         0x03C
#define GBA_REG_OFFS_BG3Y_L       0x03C
#define GBA_REG_OFFS_BG3Y_H       0x03E
#define GBA_REG_OFFS_WIN0H        0x040
#define GBA_REG_OFFS_WIN1H        0x042
#define GBA_REG_OFFS_WIN0V        0x044
#define GBA_REG_OFFS_WIN1V        0x046
#define GBA_REG_OFFS_WININ        0x048
#define GBA_REG_OFFS_WINOUT       0x04A
#define GBA_REG_OFFS_MOSAIC       0x04C
#define GBA_REG_OFFS_BLDCNT       0x050
#define GBA_REG_OFFS_BLDALPHA     0x052
#define GBA_REG_OFFS_BLDY         0x054
#define GBA_REG_OFFS_SOUND1CNT_L  0x060
#define GBA_REG_OFFS_SOUND1CNT_H  0x062
#define GBA_REG_OFFS_SOUND1CNT_X  0x064
#define GBA_REG_OFFS_SOUND2CNT_L  0x068
#define GBA_REG_OFFS_SOUND2CNT_H  0x06C
#define GBA_REG_OFFS_SOUND3CNT_L  0x070
#define GBA_REG_OFFS_SOUND3CNT_H  0x072
#define GBA_REG_OFFS_SOUND3CNT_X  0x074
#define GBA_REG_OFFS_SOUND4CNT_L  0x078
#define GBA_REG_OFFS_SOUND4CNT_H  0x07C
#define GBA_REG_OFFS_SOUNDCNT_L   0x080
#define GBA_REG_OFFS_SOUNDCNT_H   0x082
#define GBA_REG_OFFS_SOUNDCNT_X   0x084
#define GBA_REG_OFFS_SOUNDBIAS    0x088
#define GBA_REG_OFFS_WAVE_RAM0    0x090
#define GBA_REG_OFFS_WAVE_RAM0_L  0x090
#define GBA_REG_OFFS_WAVE_RAM0_H  0x092
#define GBA_REG_OFFS_WAVE_RAM1    0x094
#define GBA_REG_OFFS_WAVE_RAM1_L  0x094
#define GBA_REG_OFFS_WAVE_RAM1_H  0x096
#define GBA_REG_OFFS_WAVE_RAM2    0x098
#define GBA_REG_OFFS_WAVE_RAM2_L  0x098
#define GBA_REG_OFFS_WAVE_RAM2_H  0x09A
#define GBA_REG_OFFS_WAVE_RAM3    0x09C
#define GBA_REG_OFFS_WAVE_RAM3_L  0x09C
#define GBA_REG_OFFS_WAVE_RAM3_H  0x09E
#define GBA_REG_OFFS_FIFO_A       0x0A0
#define GBA_REG_OFFS_FIFO_A_L     0x0A0
#define GBA_REG_OFFS_FIFO_A_H     0x0A2
#define GBA_REG_OFFS_FIFO_B       0x0A4
#define GBA_REG_OFFS_FIFO_B_L     0x0A4
#define GBA_REG_OFFS_FIFO_B_H     0x0A6
#define GBA_REG_OFFS_DMA0SAD      0x0B0
#define GBA_REG_OFFS_DMA0SAD_L    0x0B0
#define GBA_REG_OFFS_DMA0SAD_H    0x0B2
#define GBA_REG_OFFS_DMA0DAD      0x0B4
#define GBA_REG_OFFS_DMA0DAD_L    0x0B4
#define GBA_REG_OFFS_DMA0DAD_H    0x0B6
#define GBA_REG_OFFS_DMA0CNT      0x0B8
#define GBA_REG_OFFS_DMA0CNT_L    0x0B8
#define GBA_REG_OFFS_DMA0CNT_H    0x0BA
#define GBA_REG_OFFS_DMA1SAD      0x0BC
#define GBA_REG_OFFS_DMA1SAD_L    0x0BC
#define GBA_REG_OFFS_DMA1SAD_H    0x0BE
#define GBA_REG_OFFS_DMA1DAD      0x0C0
#define GBA_REG_OFFS_DMA1DAD_L    0x0C0
#define GBA_REG_OFFS_DMA1DAD_H    0x0C2
#define GBA_REG_OFFS_DMA1CNT      0x0C4
#define GBA_REG_OFFS_DMA1CNT_L    0x0C4
#define GBA_REG_OFFS_DMA1CNT_H    0x0C6
#define GBA_REG_OFFS_DMA2SAD      0x0C8
#define GBA_REG_OFFS_DMA2SAD_L    0x0C8
#define GBA_REG_OFFS_DMA2SAD_H    0x0CA
#define GBA_REG_OFFS_DMA2DAD      0x0CC
#define GBA_REG_OFFS_DMA2DAD_L    0x0CC
#define GBA_REG_OFFS_DMA2DAD_H    0x0CE
#define GBA_REG_OFFS_DMA2CNT      0x0D0
#define GBA_REG_OFFS_DMA2CNT_L    0x0D0
#define GBA_REG_OFFS_DMA2CNT_H    0x0D2
#define GBA_REG_OFFS_DMA3SAD      0x0D4
#define GBA_REG_OFFS_DMA3SAD_L    0x0D4
#define GBA_REG_OFFS_DMA3SAD_H    0x0D6
#define GBA_REG_OFFS_DMA3DAD      0x0D8
#define GBA_REG_OFFS_DMA3DAD_L    0x0D8
#define GBA_REG_OFFS_DMA3DAD_H    0x0DA
#define GBA_REG_OFFS_DMA3CNT      0x0DC
#define GBA_REG_OFFS_DMA3CNT_L    0x0DC
#define GBA_REG_OFFS_DMA3CNT_H    0x0DE
#define GBA_REG_OFFS_TM0CNT       0x100
#define GBA_REG_OFFS_TM0CNT_L     0x100
#define GBA_REG_OFFS_TM0CNT_H     0x102
#define GBA_REG_OFFS_TM1CNT       0x104
#define GBA_REG_OFFS_TM1CNT_L     0x104
#define GBA_REG_OFFS_TM1CNT_H     0x106
#define GBA_REG_OFFS_TM2CNT       0x108
#define GBA_REG_OFFS_TM2CNT_L     0x108
#define GBA_REG_OFFS_TM2CNT_H     0x10A
#define GBA_REG_OFFS_TM3CNT       0x10C
#define GBA_REG_OFFS_TM3CNT_L     0x10C
#define GBA_REG_OFFS_TM3CNT_H     0x10E
#define GBA_REG_OFFS_SIODATA32    0x120
#define GBA_REG_OFFS_SIODATA32_L  0x120
#define GBA_REG_OFFS_SIOMULTI0    0x120
#define GBA_REG_OFFS_SIODATA32_H  0x122
#define GBA_REG_OFFS_SIOMULTI1    0x122
#define GBA_REG_OFFS_SIOMULTI2    0x124
#define GBA_REG_OFFS_SIOMULTI3    0x126
#define GBA_REG_OFFS_SIOCNT       0x128
#define GBA_REG_OFFS_SIOMULTI_SEND 0x12A
#define GBA_REG_OFFS_SIODATA8     0x12A
#define GBA_REG_OFFS_KEYINPUT     0x130
#define GBA_REG_OFFS_KEYCNT       0x132
#define GBA_REG_OFFS_RCNT         0x134
#define GBA_REG_OFFS_JOYCNT       0x140
#define GBA_REG_OFFS_JOY_RECV     0x150
#define GBA_REG_OFFS_JOY_RECV_L   0x150
#define GBA_REG_OFFS_JOY_RECV_H   0x152
#define GBA_REG_OFFS_JOY_TRANS    0x154
#define GBA_REG_OFFS_JOY_TRANS_L  0x154
#define GBA_REG_OFFS_JOY_TRANS_H  0x156
#define GBA_REG_OFFS_JOYSTAT      0x158
#define GBA_REG_OFFS_IE           0x200
#define GBA_REG_OFFS_IF           0x202
#define GBA_REG_OFFS_WAITCNT      0x204
#define GBA_REG_OFFS_IME          0x208
#define GBA_REG_OFFS_POSTFLG      0x300
#define GBA_REG_OFFS_HALTCNT      0x301
